### Trigger Resets ###

execute as @a[tag=state.wallrunning,nbt={OnGround:1b}] run scoreboard players set @s renegade.parkour.timer 0
execute as @a[tag=state.pending_wallrun_refresh] at @s positioned ~ ~1.5 ~ if block ^0.3125 ^ ^ #renegade.core:nonsolid if block ^-0.3125 ^ ^ #renegade.core:nonsolid if block ^ ^ ^0.5 #renegade.core:nonsolid run scoreboard players set @s renegade.parkour.timer 0
execute as @a[tag=state.pending_wallrun_refresh] at @s positioned ~ ~1.5 ~ if block ^0.3125 ^ ^ #renegade.core:nonsolid if block ^-0.3125 ^ ^ #renegade.core:nonsolid if block ^ ^ ^0.5 #renegade.core:nonsolid run tag @s remove state.pending_wallrun_refresh
execute as @a[tag=state.wallrunning,nbt={OnGround:1b}] run tag @s remove state.wallrunning

execute as @a unless predicate renegade.core:general/entity_states/sprinting run scoreboard players set @s renegade.parkour.runDist 0
execute as @a[tag=state.sliding] unless predicate renegade.core:general/entity_states/sneaking run scoreboard players set @s renegade.parkour.timer 0
execute as @a[tag=state.sliding] unless predicate renegade.core:general/entity_states/sneaking run scoreboard players set @s renegade.parkour.runDist 0
execute as @a[tag=state.sliding] unless predicate renegade.core:general/entity_states/sneaking run tag @s remove state.sliding

execute as @a[tag=state.mantling] run effect clear @s levitation
execute as @a[tag=state.mantling,nbt={OnGround:1b}] run tag @s remove state.mantling

execute as @e[tag=state.slammed] run effect clear @s levitation
execute as @e[tag=state.slammed] run tag @s remove state.slammed

execute as @a[tag=state.wallkicking] run effect clear @s levitation
execute as @a[tag=state.wallkicking] run tag @s remove state.wallkicking



### Helper Entity Actions ###

execute unless entity @e[tag=assistant.wallkick_launch] run gamerule maxEntityCramming 24
execute as @e[tag=assistant.wallkick_launch,scores={renegade.parkour.timer=2..}] at @s run tp @s 0 -512 0
execute as @e[tag=assistant.wallkick_launch,scores={renegade.parkour.timer=5..}] run kill @s
execute as @e[tag=assistant.wallkick_launch] at @s run scoreboard players add @s renegade.parkour.timer 1



### Abilities ###

execute if score #configs.parkour.enableWallRun renegade.core.Debug matches 1 as @a[tag=whitelisted.parkour,tag=!disabled.wallrun] at @s run function renegade.parkour:parkour/wallrun_trigger
execute as @a[tag=disabled.wallrun,nbt={OnGround:1b}] run tag @s remove disabled.wallrun

execute if score #configs.parkour.enableSlide renegade.core.Debug matches 1 as @a[tag=whitelisted.parkour,tag=!disabled.slide] at @s run function renegade.parkour:parkour/slide_trigger
execute as @a[nbt={OnGround:1b},scores={renegade.parkour.runDist=..200}] if predicate renegade.core:general/entity_states/sneaking run scoreboard players set @s renegade.parkour.runDist 0
execute as @a[tag=disabled.slide,nbt={OnGround:1b},scores={renegade.parkour.runDist=200..}] unless predicate renegade.core:general/entity_states/sneaking run tag @s remove disabled.slide

execute if score #configs.parkour.enableMantle renegade.core.Debug matches 1 as @a[tag=whitelisted.parkour,tag=!disabled.mantle] at @s run function renegade.parkour:parkour/mantle_trigger
execute as @a[tag=disabled.mantle,tag=!state.mantling,nbt={OnGround:1b}] run tag @s remove disabled.mantle

execute if score #configs.parkour.enableSlam renegade.core.Debug matches 1 as @a[tag=whitelisted.parkour,tag=!disabled.slam,tag=prepared.slam,tag=!state.mantling] at @s run function renegade.parkour:parkour/slam_trigger
execute as @a[tag=preparing.slam,nbt={OnGround:1b}] run tag @s remove preparing.slam
execute as @a[tag=prepared.slam,nbt={OnGround:1b}] run tag @s remove prepared.slam
execute as @a[tag=!disabled.slam,tag=!preparing.slam,tag=!state.wallrunning,nbt={OnGround:0b}] at @s if predicate renegade.core:general/entity_states/sneaking run tag @s add preparing.slam
execute as @a[tag=!disabled.slam,tag=preparing.slam,tag=!prepared.slam,nbt={OnGround:0b}] at @s unless predicate renegade.core:general/entity_states/sneaking run tag @s add prepared.slam
execute as @a[tag=disabled.slam,nbt={OnGround:1b}] run tag @s remove disabled.slam

execute if score #configs.parkour.enableWallKick renegade.core.Debug matches 1 as @a[tag=whitelisted.parkour,tag=!disabled.wallkick,tag=!state.mantling,tag=state.wallrunning] at @s run function renegade.parkour:parkour/wallkick_trigger
execute as @a[tag=disabled.wallkick] at @s positioned ~ ~1.5 ~ if block ^0.5 ^ ^ #renegade.core:nonsolid if block ^-0.5 ^ ^ #renegade.core:nonsolid if block ^ ^ ^-0.5 #renegade.core:nonsolid run tag @s remove disabled.wallkick